
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class PreviewsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const previews = await db.previews.create(
            {
                id: data.id || undefined,
        
        preview_type: data.preview_type
        ||
        null
            ,
            
        preview_url: data.preview_url
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        built_at: data.built_at
        ||
        null
            ,
            
        expires_at: data.expires_at
        ||
        null
            ,
            
        build_log: data.build_log
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await previews.setProject( data.project || null, {
            transaction,
        });
        
        await previews.setCreated_by( data.created_by || null, {
            transaction,
        });
        
        await previews.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return previews;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const previewsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                preview_type: item.preview_type
            ||
            null
            ,
            
                preview_url: item.preview_url
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                built_at: item.built_at
            ||
            null
            ,
            
                expires_at: item.expires_at
            ||
            null
            ,
            
                build_log: item.build_log
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const previews = await db.previews.bulkCreate(previewsData, { transaction });

        // For each item created, replace relation files
        

        return previews;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const previews = await db.previews.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.preview_type !== undefined) updatePayload.preview_type = data.preview_type;
        
        
        if (data.preview_url !== undefined) updatePayload.preview_url = data.preview_url;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.built_at !== undefined) updatePayload.built_at = data.built_at;
        
        
        if (data.expires_at !== undefined) updatePayload.expires_at = data.expires_at;
        
        
        if (data.build_log !== undefined) updatePayload.build_log = data.build_log;
        
        
        updatePayload.updatedById = currentUser.id;

        await previews.update(updatePayload, {transaction});

        
        
        if (data.project !== undefined) {
            await previews.setProject(
              
              data.project,
              
              { transaction }
            );
        }
        
        if (data.created_by !== undefined) {
            await previews.setCreated_by(
              
              data.created_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await previews.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return previews;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const previews = await db.previews.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of previews) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of previews) {
                await record.destroy({transaction});
            }
        });


        return previews;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const previews = await db.previews.findByPk(id, options);

        await previews.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await previews.destroy({
            transaction
        });

        return previews;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const previews = await db.previews.findOne(
            { where },
            { transaction },
        );

        if (!previews) {
            return previews;
        }

        const output = previews.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.project = await previews.getProject({
            transaction
        });
        
        
        output.created_by = await previews.getCreated_by({
            transaction
        });
        
        
        output.organizations = await previews.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.projects,
        as: 'project',
        
        where: filter.project ? {
          [Op.or]: [
            { id: { [Op.in]: filter.project.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.project.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'created_by',
        
        where: filter.created_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.created_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.created_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.preview_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'previews',
                        'preview_url',
                        filter.preview_url,
                    ),
                };
            }
            
            if (filter.build_log) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'previews',
                        'build_log',
                        filter.build_log,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            built_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    expires_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.built_atRange) {
                const [start, end] = filter.built_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    built_at: {
                    ...where.built_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    built_at: {
                    ...where.built_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expires_atRange) {
                const [start, end] = filter.expires_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.preview_type) {
                where = {
                    ...where,
                preview_type: filter.preview_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.previews.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'previews',
                        'preview_url',
                        query,
                    ),
                ],
            };
        }

        const records = await db.previews.findAll({
            attributes: [ 'id', 'preview_url' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['preview_url', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.preview_url,
        }));
    }

    
};

